VERSION 5.00
Begin VB.UserControl UserControl1 
   BackColor       =   &H000080FF&
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   FillColor       =   &H000080FF&
   ScaleHeight     =   3600
   ScaleWidth      =   4800
   Begin VB.Shape Shape3 
      BorderColor     =   &H0080C0FF&
      FillColor       =   &H000080FF&
      FillStyle       =   0  'Solid
      Height          =   255
      Left            =   0
      Top             =   1200
      Visible         =   0   'False
      Width           =   3135
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Center
      BackStyle       =   0  'Transparent
      Caption         =   "Label1"
      BeginProperty Font 
         Name            =   "Segoe UI"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00FFFFFF&
      Height          =   255
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   15
   End
   Begin VB.Shape Shape2 
      BorderStyle     =   0  'Transparent
      FillColor       =   &H0080C0FF&
      FillStyle       =   4  'Upward Diagonal
      Height          =   255
      Left            =   0
      Top             =   0
      Width           =   15
   End
   Begin VB.Shape Shape1 
      BorderColor     =   &H0080C0FF&
      FillColor       =   &H000080FF&
      FillStyle       =   0  'Solid
      Height          =   255
      Left            =   0
      Top             =   0
      Width           =   3135
   End
End
Attribute VB_Name = "UserControl1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit 'blah

Private barMin As Long 'holds the min value for progressbar
Private barValue As Long 'holds the current value for progressbar
Private barMax As Long 'holds the max value for progressbar



Private Sub UserControl_Initialize()

On Error Resume Next
With UserControl
.Height = Shape1.Height
.Width = Shape1.Width
End With

Label1.Top = UserControl.Height / 2

End Sub

Private Sub UserControl_Resize() 'aligns the images so they will resize with the control

On Error Resume Next

Shape1.Height = UserControl.Height
Shape1.Width = UserControl.Width
Shape2.Height = Shape1.Height
Label1.Height = Shape1.Height

Label1.Top = UserControl.Height / 2

'Bar_Draw

End Sub

Public Property Let Value(ByVal val As Long) 'making sure the value doesn't go below min or above max
    
    If val > barMax Then val = barMax
    If val < barMin Then val = barMin
    barValue = val
    Bar_Draw 'update the progressbar to display the current value
    PropertyChanged "Value"
    
End Property

Public Property Get Value() As Long 'reading the current value
    
    Value = barValue
    
End Property

Public Property Let Max(ByVal val As Long) 'making sure the max is valid and above the min
    
    If val < 1 Then val = 1
    If val <= barMin Then val = barMin + 1
    barMax = val
    If Value > barMax Then Value = barMax
    Bar_Draw 'update the progressbar to display the current value
    PropertyChanged "Max"
    
End Property
Public Property Get Max() As Long 'reading the min value
    
    Max = barMax
    
End Property

Public Property Let Min(ByVal val As Long) 'making sure the min is valid and below the max
    
    If val >= barMax Then val = Max - 1
    If val < 0 Then val = 0
    barMin = val
    If Value < barMin Then Value = barMin
    Bar_Draw 'update the progressbar to display the current value
    PropertyChanged "Min"
    
End Property
Public Property Get Min() As Long 'reading the min value
    
    Min = barMin
    
End Property

Private Sub UserControl_InitProperties() 'this is what the the control starts of with when placed in design-time
    
    Max = 100
    Min = 0
    Value = 0
    
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag) 'this will load the values while in design-time
    
    On Error Resume Next
    Max = PropBag.ReadProperty("Max", 100)
    Min = PropBag.ReadProperty("Min", 0)
    Value = PropBag.ReadProperty("Value", 50)
    
    Label1.Caption = PropBag.ReadProperty("Caption", "Please Wait!")
    Set Label1.Font = PropBag.ReadProperty("Font", Ambient.Font)
    
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag) 'this will save the values while in design-time
    
    PropBag.WriteProperty "Max", Max, 100
    PropBag.WriteProperty "Min", Min, 0
    PropBag.WriteProperty "Value", Value, 50
    
    Call PropBag.WriteProperty("Caption", Label1.Caption, "Please Wait!")
    Call PropBag.WriteProperty("Font", Label1.Font, Ambient.Font)
    
End Sub

Private Sub Bar_Draw() 'this is where the calculating is done to display the bar

Dim i, s, z, y, q As Long
    i = barMax: s = barValue: z = barMax 'getting the needed values incase we need to alter them
    y = (s * 100 / z) 'this is finding out what the current value is in a percentage compared to the max
    q = (y * UserControl.Width / 100) 'we now convert the percentage to a mesurement compared to the usercontrols width
If s = 0 Then Shape2.Width = 0
If s >= 1 Then Shape3.Left = Shape2.Width: Shape2.Width = q   'if the current value is above 1 then display the start of bar as green and stretch the progress to display current value
Label1.Width = Shape2.Width

End Sub

Public Property Get Caption() As String

    Caption = Label1.Caption
    
End Property

Public Property Let Caption(ByVal New_Caption As String)
    Label1.Caption() = New_Caption
    'once we change the caption let the control resize itself
    Call UserControl_Resize
    PropertyChanged "Caption"
    
End Property

Public Property Get Font() As Font

    Set Font = Label1.Font
        
End Property

Public Property Set Font(ByVal New_Font As Font)

    Set Label1.Font = New_Font
    
    'once we change the size of the font let the control resize itself
    Call UserControl_Resize
    PropertyChanged "Font"
    
End Property
